//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
//
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <saga/adaptors/config.hpp>
#include <saga/adaptors/adaptor.hpp>

#include "default_advert_adaptor.hpp"
#include "advertdirectory.hpp"
#include "advert.hpp"

SAGA_ADAPTOR_REGISTER (advert::adaptor);

///////////////////////////////////////////////////////////////////////////////
namespace advert
{

//  register function for the SAGA engine
    saga::impl::adaptor_selector::adaptor_info_list_type
        adaptor::adaptor_register(saga::impl::session *s)
    {
        // list of implemented cpi's
        saga::impl::adaptor_selector::adaptor_info_list_type list;

        // create preferences
        preference_type prefs; // (std::string ("security"), std::string ("none"));

        // create advert and advert directory cpi infos (each adaptor 
        // instance gets its own uuid) and add cpi_infos to list
        advert_cpi_impl::register_cpi(list, prefs, adaptor_uuid_);
        advertdirectory_cpi_impl::register_cpi(list, prefs, adaptor_uuid_);

        // and return list
        return list;
    }

///////////////////////////////////////////////////////////////////////////////
}   // namespace advert

