//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#if !defined(ADAPTORS_DEFAULT_JOB_DEFAULT_JOB_OSTREAM_HPP)
#define ADAPTORS_DEFAULT_JOB_DEFAULT_JOB_OSTREAM_HPP

#include <saga/util.hpp>
#include <saga/base.hpp>

#include <impl/job.hpp>

#include "default_job_stream.hpp"

///////////////////////////////////////////////////////////////////////////////
class default_job_ostream 
:   public saga::job::ostream
{
private:
    typedef impl::default_job_stream<saga::adaptors::ostream_ptr> impl_type;
    
public:
    template <typename Stream>
    default_job_ostream(saga::impl::v1_0::job_cpi* cpi, Stream& child_ostream)
    :   saga::job::ostream(new impl_type(cpi, child_ostream.rdbuf()))
    {
    }
};

#endif // !defined(ADAPTORS_DEFAULT_JOB_DEFAULT_JOB_OSTREAM_HPP)
