//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#if !defined(ADAPTORS_DEFAULT_JOB_DEFAULT_JOB_STREAM_HPP)
#define ADAPTORS_DEFAULT_JOB_DEFAULT_JOB_STREAM_HPP

#include <iosfwd>

//#include <saga/util.hpp>
//#include <saga/base.hpp>
#include <impl/engine/cpi.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace impl
{
    template <typename Base>
    class default_job_stream
    :   public Base
    {
    private:
        typedef Base base_type;
        
    public:
        default_job_stream(saga::impl::v1_0::job_cpi* cpi, std::streambuf *buf)
        :   base_type(buf),
            cpi_(cpi->shared_from_this()),
            proxy_(cpi->get_proxy()->shared_from_this())
        {
        }

    private:
        // a saga stream has to keep alive the proxy and the cpi instance
        TR1::shared_ptr<saga::impl::v1_0::cpi> cpi_;
        TR1::shared_ptr<saga::impl::proxy> proxy_;
    };
    
///////////////////////////////////////////////////////////////////////////////
}   // namespace impl

#endif // !defined(ADAPTORS_DEFAULT_JOB_DEFAULT_JOB_STREAM_HPP)
