/*
**  OSSP uuid - Universally Unique Identifier
**  Copyright (c) 2004 Ralf S. Engelschall <rse@engelschall.com>
**  Copyright (c) 2004 The OSSP Project <http://www.ossp.org/>
**
**  This file is part of OSSP uuid, a library for the generation
**  of UUIDs which can found at http://www.ossp.org/pkg/lib/uuid/
**
**  Permission to use, copy, modify, and distribute this software for
**  any purpose with or without fee is hereby granted, provided that
**  the above copyright notice and this permission notice appear in all
**  copies.
**
**  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
**  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
**  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
**  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
**  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
**  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
**  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
**  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
**  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
**  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
**  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
**  SUCH DAMAGE.
**
**  saga_uuid_ac.c: auto-configuration
*/

#ifndef __SAGA_UUID_AC_H__
#define __SAGA_UUID_AC_H__

#include <saga/types.hpp>

/* define boolean values */
#define SAGA_UUID_FALSE 0
#define SAGA_UUID_TRUE  !SAGA_UUID_FALSE

typedef saga::int8_t      saga_uuid_int8_t  ;
typedef saga::uint8_t     saga_uuid_uint8_t ;
typedef saga::int16_t     saga_uuid_int16_t ;
typedef saga::uint16_t    saga_uuid_uint16_t;
typedef saga::int32_t     saga_uuid_int32_t ;
typedef saga::uint32_t    saga_uuid_uint32_t;
#ifndef BOOST_NO_INT64_T
typedef saga::int64_t     saga_uuid_int64_t ;
typedef saga::uint64_t    saga_uuid_uint64_t;
#endif
typedef float             saga_uuid_float_t ;
typedef double            saga_uuid_double_t;

#endif /* __SAGA_UUID_AC_H__ */

