//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef SAGA_IMPL_EXCEPTION_LIST_HPP
#define SAGA_IMPL_EXCEPTION_LIST_HPP

#include <list>
#include <algorithm>

#include <saga/base.hpp>
#include <saga/util.hpp>
#include <saga/error.hpp>
#include <saga/exception.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga { namespace impl {

    class exception_list
    {
    private:
        typedef std::list<saga::exception> exception_list_type;
        exception_list_type exceptions_;
        
    public:
        SAGA_EXPORT exception_list();
        explicit SAGA_EXPORT exception_list(saga::exception const& e);
        
        SAGA_EXPORT void add(saga::exception const& e);
        SAGA_EXPORT saga::error get_error() const;
        SAGA_EXPORT std::string get_message() const;
        
        SAGA_EXPORT std::size_t get_error_count() const;
    };
    
///////////////////////////////////////////////////////////////////////////////
}}    // namespace saga::impl

#endif // !SAGA_IMPL_EXCEPTION_LIST_HPP


