#if defined(__WAVE__) && defined(SAGA_CREATE_PREPROCESSED_FILES)
#pragma wave option(preserve: 2, line: 0, output: "preprocessed/service.cpp")
#endif
//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#if defined(__WAVE__) && defined(SAGA_CREATE_PREPROCESSED_FILES)
#pragma wave option(preserve: 0, output: null)
#endif

#include <saga/adaptors/task.hpp>
#include <impl/packages/job/job_service.hpp>
#include <saga/adaptors/instance_data.hpp>
#include <saga/adaptors/packages/job_service_cpi_instance_data.hpp>
#include <impl/engine/task_get_bulk_adaptor.hpp>

#ifdef SAGA_DEBUG
#include <impl/packages/data/service/preprocessed/service.cpp>
#else

#if defined(__WAVE__) && defined(SAGA_CREATE_PREPROCESSED_FILES)
#pragma wave option(preserve: 2, output: "preprocessed/service.cpp")
#endif
///////////////////////////////////////////////////////////////////////////////
namespace saga 
{ 
  namespace impl 
  {
    service::service (saga::session const& s, std::string const& rm)
        : proxy (saga::object::JobService, s)
    {
        // initialize the instance data
        typedef adaptors::v1_0::service_cpi_instance_data instance_data_type;
        typedef adaptors::instance_data <instance_data_type> service_instance_data;

        {
            service_instance_data data;
            data.init_data (this, TR1::shared_ptr <instance_data_type> (
                new instance_data_type (rm)));
        } // service_instance_data lock goes out of scope
    }
    
    void service::init()
    {
        // initialize a CPI instance and execute required functions
        this->initcpi(saga::adaptors::service_cpi);
    }
    
    service::~service (void) 
    {
        // free the instance data
        typedef adaptors::v1_0::service_cpi_instance_data instance_data_type;
        typedef adaptors::instance_data <instance_data_type> service_instance_data;

        service_instance_data data;
        data.release_data (this);
    }

    // API methods of service
    SAGA_CALL_IMPL_IMPL_1 (service, service_cpi, saga::job::job, create_job, saga::job::description)
    SAGA_CALL_IMPL_IMPL_5 (service, service_cpi, saga::job::job, run_job, 
        std::string, std::string, saga::job::ostream&, saga::job::istream&, saga::job::istream&)
    SAGA_CALL_IMPL_IMPL_0 (service, service_cpi, std::vector<std::string>, list)
    SAGA_CALL_IMPL_IMPL_1 (service, service_cpi, saga::job::job, get_job,  std::string)
    SAGA_CALL_IMPL_IMPL_0 (service, service_cpi, saga::job::self, get_self)

  } // namespace impl

} // namespace saga
///////////////////////////////////////////////////////////////////////////////


#endif

