#if defined(__WAVE__) && defined(SAGA_CREATE_PREPROCESSED_FILES)
#pragma wave option(preserve: 2, line: 0, output: "preprocessed/server.cpp")
#endif
//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
//  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
// 
//  Use, modification and distribution is subject to the Boost Software
//  License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
//  http://www.boost.org/LICENSE_1_0.txt)

#if defined(__WAVE__) && defined(SAGA_CREATE_PREPROCESSED_FILES)
#pragma wave option(output: null)
#endif

// needs tasks for async ops
#include <saga/util.hpp>
#include <saga/adaptors/task.hpp>

#include <impl/call.hpp>
#include <impl/engine/task.hpp>
#include <impl/engine/sync_async.hpp>

// own header file
#include <impl/stream.hpp>
#include <saga/adaptors/instance_data.hpp>
#include <saga/adaptors/packages/stream_service_cpi_instance_data.hpp>

#ifdef SAGA_DEBUG
#include <impl/packages/stream/preprocessed/server.cpp>
#else

#if defined(__WAVE__) && defined(SAGA_CREATE_PREPROCESSED_FILES)
#pragma wave option(output: "preprocessed/server.cpp")
#endif
///////////////////////////////////////////////////////////////////////////////
namespace saga 
{ 
  namespace impl 
  {
    server::server (saga::session const & s, 
                                  std::string   const & loc) 
        : proxy   (saga::object::StreamService, s)
    {
      // initialize the instance data
      typedef adaptors::v1_0::server_cpi_instance_data instance_data_type;
      typedef adaptors::instance_data <instance_data_type> server_instance_data;

      server_instance_data data;
      data.init_data (this, 
          TR1::shared_ptr <instance_data_type>(new instance_data_type (loc)));
    }

    void server::init ()
    {
        // initialize a CPI instance and execute required functions
        this->initcpi(saga::adaptors::server_cpi);
    }

    server::~server (void) 
    {  
      // free the instance data
      typedef adaptors::v1_0::server_cpi_instance_data instance_data_type;
      typedef adaptors::instance_data <instance_data_type> server_instance_data;

      server_instance_data data;
      data.release_data (this);
    }

    // stream server methods
    SAGA_CALL_IMPL_IMPL_1 (server, server_cpi, saga::stream::stream, serve, double)
    SAGA_CALL_IMPL_IMPL_0 (server, server_cpi, std::string,  get_url)
    SAGA_CALL_IMPL_IMPL_1 (server, server_cpi, saga::void_t, close, double)

  } // namespace impl

} // namespace saga
////////////////////////////////////////////////////////////////////////////////

#endif // SAGA_DEBUG

