//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef SAGA_IMPLE_ENGINE_RUNTIME_HPP
#define SAGA_IMPLE_ENGINE_RUNTIME_HPP

#include <saga/util.hpp>
#include <saga/base.hpp>
#include <saga/impl_base.hpp>

/// @cond
/** These methods are not within API scope */
namespace saga { namespace impl {

    // The SAGA runtime helper class
    
    // This is a helper class which wraps the needed access to the 
    // internal implementation classes
    struct runtime
    {
        SAGA_EXPORT static TR1::shared_ptr <session> 
            get_impl (saga::session const & s);
        SAGA_EXPORT static task_interface const* get_impl (task_type const & t);
        SAGA_EXPORT static task_interface* get_impl (task_type& t);
        SAGA_EXPORT static TR1::shared_ptr <task_container> 
            get_impl (saga::task_container const & t);
            
        SAGA_EXPORT static TR1::shared_ptr <saga::impl::object> 
            get_impl_object (saga::object const& obj);
        SAGA_EXPORT static saga::object 
            get_object(TR1::shared_ptr<saga::impl::object> impl);
            
        SAGA_EXPORT static TR1::shared_ptr <impl::url>
            get_impl (saga::url const& u);
    };
  }
} 
/// @endcond

#endif // SAGA_IMPLE_ENGINE_RUNTIME_HPP

