//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
//  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <saga/util.hpp>
#include <saga/exception.hpp>
#include <saga/object.hpp>
#include <saga/task.hpp>
#include <saga/attribute.hpp>
#include <saga/context.hpp>

#include <impl/exception.hpp>
#include <impl/engine/object.hpp>
#include <impl/engine/attribute.hpp> 
#include <impl/engine/context_base.hpp>

#include <saga/detail/attribute_impl.hpp>

namespace saga 
{
    attribute::attribute (saga::object rhs)
      : impl_ (rhs.get_impl())
    {
    }

    attribute::attribute (saga::impl::object *impl)
      : impl_ (impl->shared_from_this())
    {
    }

    attribute::~attribute (void)
    {
    }

    ///////////////////////////////////////////////////////////////////////////
    //  implement the attribute functions (we need to explicitly specialize 
    //  the template because the functions are not implemented inline)
    template struct detail::attribute<attribute>;
    
    template struct detail::attribute_priv<attribute, task_base::Sync>;
    template struct detail::attribute_priv<attribute, task_base::Async>;
    template struct detail::attribute_priv<attribute, task_base::Task>;
  
///////////////////////////////////////////////////////////////////////////////
} // namespace saga

