//  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Use, modification and distribution is subject to the Boost Software
//  License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
//  http://www.boost.org/LICENSE_1_0.txt)

// include the object implementation we want to use
#include <impl/engine/object.hpp>

// include the basic header file
#include <saga/exception.hpp>
#include <saga/object.hpp>

// we need saga::session and saga::uuid
#include <saga/session.hpp>
#include <saga/uuid.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga 
{
  object::object (saga::impl::object * init)
    : impl_ (init)
  {
  }
  
  object::object (TR1::shared_ptr<saga::impl::object> init)
    : impl_ (init)
  {
  }
  
  // constructor for objects without session
  object::object ()
  {
  }

  saga::object::type object::get_type (void) const
  {
    return (impl_->get_type());
  }

  saga::uuid object::get_id (void) const
  {
    return (impl_->get_uuid ());
  }

  saga::session object::get_session  (void) const
  {
    return (impl_->get_session ());
  }

  saga::object object::clone() const
  {
    return impl_->clone();
  }
  
} // namespace saga 
///////////////////////////////////////////////////////////////////////////////

