#if defined(__WAVE__)
#pragma wave option(preserve: 2, line: 1, output: "preprocessed/directory.cpp")
#endif
//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
//  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#if defined(__WAVE__)
#pragma wave option(preserve: 0, output: null)
#endif
// include directory api and implementation
#include <string>
#include <vector>

// include the package we implement
#include <saga/call.hpp>
#include <saga/file.hpp>
#include <impl/file.hpp>

#ifdef SAGA_DEBUG
#include <saga/packages/file/preprocessed/directory.cpp>
#else

#if defined(__WAVE__)
#pragma wave option(preserve: 2, line: 1, output: "preprocessed/directory.cpp")
#endif
///////////////////////////////////////////////////////////////////////////////
namespace saga 
{
    namespace filesystem {
  directory::directory (session     const & s,
                        std::string const & url, 
                        int                 mode)
        : name_space::directory (new saga::impl::directory (s, url, mode))
  {
    this->saga::object::get_impl()->init();
  }

  directory::directory (std::string const & url, 
                        int                 mode)
    : name_space::directory (new saga::impl::directory (detail::get_the_session (), url, mode))
  {
    this->saga::object::get_impl()->init();
  }

  directory::directory (saga::object const& o)
    : name_space::directory(o)
  {
      if (this->get_type() != saga::object::Directory)
      {
          SAGA_THROW("Bad type conversion.", saga::BadParameter);
      }
  }

  directory::directory (void)
  {
  }

  directory::~directory (void)
  {
  }

  directory &directory::operator= (saga::object const& o)
  {
      return this->saga::name_space::directory::operator=(o), *this;
  }

  TR1::shared_ptr <saga::impl::directory> directory::get_impl() const
  { 
    typedef saga::object base_type;
    return TR1::static_pointer_cast<saga::impl::directory>(
        this->base_type::get_impl()); 
  }

  // get file info
  SAGA_CALL_IMP_1 (directory, saga::off_t, get_size, std::string)
  SAGA_CALL_IMP_1 (directory, bool,        is_file,  std::string)

  // overload open methods from namespace_dir
  SAGA_CALL_IMP_2 (directory, saga::filesystem::file,      open,     std::string, int)
  SAGA_CALL_IMP_2 (directory, saga::filesystem::directory, open_dir, std::string, int)
}
} // namespace saga
///////////////////////////////////////////////////////////////////////////////////

#endif

