//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <saga/task.hpp>
#include <saga/adaptors/attribute.hpp>
#include <saga/adaptors/metric.hpp>
#include <saga/packages/job/adaptors/job_self.hpp>

#include <impl/job.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga { namespace adaptors {

    self::self (std::string rm, saga::job::description jd, 
              saga::session const& s, 
              TR1::shared_ptr <saga::impl::v1_0::cpi> cpi_instance)
        : saga::job::self(new saga::impl::job(rm, jd, s, cpi_instance))
    {
    }

    self::self (std::string rm, saga::job::description jd, 
            TR1::shared_ptr <saga::impl::v1_0::cpi> cpi_instance)
        : saga::job::self(new saga::impl::job(rm, jd, detail::get_the_session(), cpi_instance))
    {
    }

    self::self (std::string rm, std::string jobid, saga::session const& s, 
              TR1::shared_ptr <saga::impl::v1_0::cpi> cpi_instance)
        : saga::job::self(new saga::impl::job(rm, jobid, s, cpi_instance))
    {
    }

    self::self (std::string rm, std::string jobid, 
            TR1::shared_ptr <saga::impl::v1_0::cpi> cpi_instance)
        : saga::job::self(new saga::impl::job(rm, jobid, detail::get_the_session(), cpi_instance))
    {
    }

    self::~self()
    {
    }

///////////////////////////////////////////////////////////////////////////////
}}    // namespace saga::adaptors

