//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#if !defined(SAGA_PACKAGES_JOB_ADAPTORS_JOB_SELF_HPP)
#define SAGA_PACKAGES_JOB_ADAPTORS_JOB_SELF_HPP

#include <saga/util.hpp>
#include <saga/base.hpp>
#include <saga/session.hpp>

#include <saga/job.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga { namespace adaptors {

    class SAGA_JOB_PACKAGE_EXPORT self
    :   public saga::job::self
    {
    public:
        self (std::string rm, saga::job::description jd, saga::session const& s, 
            TR1::shared_ptr <saga::impl::v1_0::cpi> cpi_instance);
        self (std::string rm, saga::job::description jd,
            TR1::shared_ptr <saga::impl::v1_0::cpi> cpi_instance);

        self (std::string rm, std::string jobid, saga::session const& s, 
            TR1::shared_ptr <saga::impl::v1_0::cpi> cpi_instance);
        self (std::string rm, std::string jobid,
            TR1::shared_ptr <saga::impl::v1_0::cpi> cpi_instance);

        ~self();
    };

///////////////////////////////////////////////////////////////////////////////
}}    // namespace saga::adaptors

#endif // !defined(SAGA_PACKAGES_JOB_ADAPTORS_JOB_SELF_HPP)
