#if defined(__WAVE__) && defined(SAGA_CREATE_PREPROCESSED_FILES)
#pragma wave option(preserve: 2, line: 1, output: "preprocessed/service.cpp")
#endif
//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#if defined(__WAVE__) && defined(SAGA_CREATE_PREPROCESSED_FILES)
#pragma wave option(output: null)
#endif

// include service api and implementation
#include <saga/job.hpp>
#include <saga/adaptors/task.hpp>
#include <impl/job.hpp>

#ifdef SAGA_DEBUG
#include <saga/packages/job/preprocessed/service.cpp>
#else

#if defined(__WAVE__) && defined(SAGA_CREATE_PREPROCESSED_FILES)
#pragma wave option(preserve: 2, line: 1, output: "preprocessed/service.cpp")
#endif
///////////////////////////////////////////////////////////////////////////////
namespace saga
{
    namespace job {
    
  service::service (session const &s, std::string const& rm)
    : saga::object (new saga::impl::service (s, rm))
  {
      this->saga::object::get_impl()->init();
  }

  service::service (std::string const& rm)
    : saga::object (new saga::impl::service (detail::get_the_session(), rm))
  {
      this->saga::object::get_impl()->init();
  }

  service::service (saga::object const& o)
    : saga::object (o)
  {
      if (this->get_type() != saga::object::JobDescription)
      {
          SAGA_THROW("Bad type conversion.", saga::BadParameter);
      }
  }

  service::~service (void)
  {
  }

  service &service::operator= (saga::object const& o)
  {
      if (this != &o) 
          this->saga::object::operator=(o);
      return *this;
  }

  TR1::shared_ptr <saga::impl::service> service::get_impl (void) const
  { 
      // FIXME: this needs documentation
      typedef saga::object base_type;
      return TR1::static_pointer_cast <saga::impl::service> (
          this->base_type::get_impl ());
  }

  // methods of the service
  SAGA_CALL_IMP_1 (service, job, create_job, description)
  SAGA_CALL_IMP_5 (service, job, run_job, std::string, std::string,
            saga::job::ostream&, saga::job::istream&, saga::job::istream&)
  SAGA_CALL_IMP_0 (service, std::vector<std::string>, list)
  SAGA_CALL_IMP_1 (service, job, get_job,  std::string)
  SAGA_CALL_IMP_0 (service, self, get_self)
}

} // namespace saga
///////////////////////////////////////////////////////////////////////////////////

#endif

