//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <saga/job.hpp>
#include <saga/adaptors/task.hpp>
#include <impl/job.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga {

    namespace job {

    ostream::ostream(saga::impl::ostream_interface *impl)
    :   std::ios(0), base_type(impl->get_streambuf()), impl_(impl)
    {
    }

    ostream::ostream(ostream const& rhs)
    :   std::ios(0), base_type(rhs.rdbuf()), impl_(rhs.impl_)
    {
        this->copyfmt(rhs);
        this->clear(rhs.rdstate());
    }

    ostream::ostream()
    :   std::ios(0), base_type(0)
    {
    }
    
    ostream& ostream::operator=(ostream const& rhs)
    {
        if (this != &rhs) {
            this->copyfmt(rhs);
            this->clear(rhs.rdstate());
            this->std::basic_ios<char>::rdbuf(rhs.rdbuf());
            impl_ = rhs.impl_;
        }
        return *this;
    }
}
///////////////////////////////////////////////////////////////////////////////
}   // namespace saga

