//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef SAGA_PACKAGES_COMM_RPC_PARAMETER_HPP
#define SAGA_PACKAGES_COMM_RPC_PARAMETER_HPP

#if defined(_MSC_VER) && (_MSC_VER >= 1200)
#pragma once
#endif 

// include dependent spec sections
#include <saga/buffer.hpp>

// suppress warnings about dependent classes not being exported from the dll
#if defined(BOOST_MSVC)
#pragma warning(push)
#pragma warning(disable: 4251 4231 4275 4660)
#endif

///////////////////////////////////////////////////////////////////////////////
namespace saga
{
    namespace rpc {
    
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */  
    enum io_mode
    {
        Unknown = -1,
        In = 1,           // input parameter
        Out = 2,          // output parameter
        InOut = In | Out  // input and output parameter
    };
    
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */  
    class SAGA_RPC_PACKAGE_EXPORT parameter 
        : public saga::mutable_buffer
    {
    protected:
        /// @cond
        /** These methods are not within API scope */
        TR1::shared_ptr <saga::impl::parameter> get_impl (void) const;
        friend class saga::impl::parameter;
        /// @endcond

    public:
        /*! \brief Brief %description starts here     
         *
         *   Detailed %description starts here.
         */  
        parameter(void* data = 0, saga::ssize_t size = -1, io_mode mode = In,
                  buffer_deleter cb = default_buffer_deleter);

        /*! \brief Brief %description starts here     
         *
         *   Detailed %description starts here.
         */  
        ~parameter();

        /*! \brief NOT in spec!     
         *
         *   Detailed %description starts here.
         */  
        io_mode get_mode() const;
        
    }; 
    };

}   
// re-enable warnings about dependent classes not being exported from the dll
#if defined(BOOST_MSVC)
#pragma warning(pop)
#endif

#endif // !defined(SAGA_PACKAGES_COMM_RPC_PARAMETER_HPP)

