//  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

//  this is needed in every file including detail/permissions_impl.hpp and not 
//  belonging to the engine
#define SAGA_NO_EXPORT_PERMISSIONS

// include rpc API and implementation
#include <saga/rpc.hpp>
#include <impl/rpc.hpp>

#include <saga/detail/permissions_impl.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga {
  namespace rpc {

  rpc::rpc (session const& s, std::string const& name)
    : saga::object (new saga::impl::rpc (s, name))
  {
    this->saga::object::get_impl()->init();
  }

  rpc::rpc (std::string const& name)
    : saga::object (new saga::impl::rpc (detail::get_the_session (), name))
  {
    this->saga::object::get_impl()->init();
  }

  rpc::rpc (void) 
  {
  }
  
  rpc::~rpc (void)
  {
  }

  boost::shared_ptr <saga::impl::rpc> rpc::get_impl (void) const
  { 
    // FIXME: this needs documentation
    typedef saga::object base_type;
    return TR1::static_pointer_cast <saga::impl::rpc>(
        this->base_type::get_impl());
  }

  SAGA_CALL_IMP_1(rpc, void_t, call, std::vector<parameter>&)
  SAGA_CALL_IMP_1(rpc, void_t, close, double)
  }

  /////////////////////////////////////////////////////////////////////////////
  //  implement the permissions functions (we need to explicitly specialize 
  //  the template because the functions are not implemented inline)
  template struct detail::permissions<rpc::rpc>;  
///////////////////////////////////////////////////////////////////////////////////
} // namespace saga

