//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <saga/util.hpp>
#include <saga/exception.hpp>
#include <saga/object.hpp>
#include <saga/task.hpp>
#include <saga/permissions.hpp>
#include <saga/context.hpp>

#include <impl/exception.hpp>
#include <impl/engine/object.hpp>
#include <impl/engine/permissions.hpp> 
#include <impl/engine/context_base.hpp>

#include <saga/detail/permissions_impl.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga 
{
    permissions::permissions (saga::object rhs)
      : impl_ (rhs.get_impl())
    {
    }

    permissions::permissions (saga::impl::object *impl)
      : impl_ (impl->shared_from_this())
    {
    }

    permissions::~permissions (void)
    {
    }

    ///////////////////////////////////////////////////////////////////////////
    //  implement the permissions functions (we need to explicitly specialize 
    //  the template because the functions are not implemented inline)
    template struct detail::permissions<permissions>;
    
    template struct detail::permissions_priv<permissions, saga::task_base::Sync>;
    template struct detail::permissions_priv<permissions, saga::task_base::Async>;
    template struct detail::permissions_priv<permissions, saga::task_base::Task>;
  
///////////////////////////////////////////////////////////////////////////////
} // namespace saga

