//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
//  Copyright (c) 2007 Ole Weidner (oweidner@cct.lsu.edu)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <string>

#include <saga/util.hpp>
#include <saga/base.hpp>

#if !defined(SAGA_SAGA_URL_HPP)
#define SAGA_SAGA_URL_HPP

// suppress warnings about dependent classes not being exported from the dll
#if defined(BOOST_MSVC)
#pragma warning(push)
#pragma warning(disable: 4251 4231 4275 4660)
#endif

///////////////////////////////////////////////////////////////////////////////
namespace saga 
{
  /*! \brief Brief %description starts here     
   *
   *   Detailed %description starts here.
   */
  class SAGA_EXPORT url 
  {
   private:
     /// @cond
     /** These methods are not within API scope */
     TR1::shared_ptr <impl::url> impl;
     friend struct impl::runtime;
     /// @endcond
     
   protected:
     /// @cond
     /** These methods are not within API scope */
     TR1::shared_ptr <impl::url> get_impl() const;
     /// @endcond
     
   public:
     url (void);
     url (std::string const & urlstr);
    ~url (void);

    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     url clone();
    
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_url       (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_authority (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_scheme    (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_host      (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_fragment  (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_path      (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_query     (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_userinfo  (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_username  (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     std::string get_password  (void) const;
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     int         get_port      (void) const;

    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_scheme               (std::string const & scheme);
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_scheme_specific_part (std::string const & scheme_specific_part);
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_host                 (std::string const & host);
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_fragment             (std::string const & fragment);
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_path                 (std::string const & path);
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_query                (std::string const & query);
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_userinfo             (std::string const & userinfo);
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_username             (std::string const & username);
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_password             (std::string const & passwd);
     
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
     void set_port                 (int port);
  };

///////////////////////////////////////////////////////////////////////////////
} // namespace saga

// re-enable warnings about dependent classes not being exported from the dll
#if defined(BOOST_MSVC)
#pragma warning(pop)
#endif

#endif // SAGA_SAGA_URL_HPP

